#ifndef MEMU_H__
#define MEMU_H__

#include "TYW_stdint.h"

#ifdef GLOBALS_MEU_PROCESS
#define EXTERN_MEU_PROCESS
#else
#define EXTERN_MEU_PROCESS extern
#endif

#define K_Line_User_RYLQQ 44
#define K_Line_User_KQGZJ 100

#define _MN_IDX_NULL 0xff
#define _MN_IDX_NULL0 0x00
#define _MN_OPR_NULL (void *)0

typedef enum
{
    /*主界面*/
    _MN_DSP_LEVEL1MENU_1 = 0, /* 00 平均车速，平均油耗*/
    _MN_DSP_LEVEL1MENU_2,     /* 01 电池电量*/
    _MN_DSP_LEVEL1MENU_3,     /* 02 DPD*/
    _MN_DSP_LEVEL1MENU_4,     /* 03 油温-转速时间*/
    _MN_DSP_LEVEL1MENU_5,     /* 04 日历*/
    _MN_DSP_LEVEL1MENU_6,     /* 05 空白*/
    _MN_DSP_LEVEPOPUP,        /* 06 报警界面显示*/

    /*一级菜单*/
    _MN_DSP_LEVEL2MENU_1, /* 07 故障码*/
    _MN_DSP_LEVEL2MENU_2, /* 08 保养通知*/
    _MN_DSP_LEVEL2MENU_3, /* 09 保养通知设定*/
    _MN_DSP_LEVEL2MENU_4, /* 10 用户设定*/
    _MN_DSP_LEVEL2MENU_5, /* 11 系统演示模式*/
    _MN_DSP_LEVEL2MENU_6, /* 12 轮胎状态显示*/

    /*二级菜单*/
    _MN_DSP_LEVEL2_1_MENU_1, /* 13 故障码*/

    _MN_DSP_LEVEL2_2_MENU_1, /* 14 发动机机油&滤清器*/
    _MN_DSP_LEVEL2_2_MENU_2, /* 15 燃油滤清器*/
    _MN_DSP_LEVEL2_2_MENU_3, /* 16 变速箱油*/
    _MN_DSP_LEVEL2_2_MENU_4, /* 17 差速器油*/
    _MN_DSP_LEVEL2_2_MENU_7, /* 18 动力转向液*/
    _MN_DSP_LEVEL2_2_MENU_8, /* 19 轮胎*/

    _MN_DSP_LEVEL2_3_MENU_1, /* 20 更换机油＆机油滤清器*/
    _MN_DSP_LEVEL2_3_MENU_2, /* 21 更换燃油滤清器*/
    _MN_DSP_LEVEL2_3_MENU_3, /* 22 更换变速箱油*/
    _MN_DSP_LEVEL2_3_MENU_4, /* 23 更换差速器油*/
    _MN_DSP_LEVEL2_3_MENU_6, /* 24 更换动力转向液*/
    _MN_DSP_LEVEL2_3_MENU_7, /* 25 轮胎换位・更换*/

    _MN_DSP_LEVEL2_4_MENU_1, /* 26 设定日期*/
    _MN_DSP_LEVEL2_4_MENU_2, /* 27 设定时间*/
    _MN_DSP_LEVEL2_4_MENU_7, /* 28 亮度调节*/
    _MN_DSP_LEVEL2_4_MENU_3, /* 29 语言设定*/
    _MN_DSP_LEVEL2_4_MENU_4, /* 30 设定节油驾驶建议*/
    _MN_DSP_LEVEL2_4_MENU_5, /* 31 TPMS轮胎设定*/
    _MN_DSP_LEVEL2_4_MENU_6, /* 32 显示设定*/

    _MN_DSP_LEVEL2_6_MENU_1, /* 33 轮胎气压*/
    _MN_DSP_LEVEL2_6_MENU_2, /* 34 轮胎温度*/

    _MN_DSP_LEVEL2_5_MENU_1, /* 35 LDWS 警报演示*/
    _MN_DSP_LEVEL2_5_MENU_2, /* 36 AEBS第1警报演示*/
    _MN_DSP_LEVEL2_5_MENU_3, /* 37 AEBS第2警报演示*/
    _MN_DSP_LEVEL2_5_MENU_4, /* 38 AEBS全力制动警报演示*/

    /*三级菜单*/
    _MN_DSP_LEVEL3_2_MENU_1, /* 39 发动机机油＆滤清器*/
    _MN_DSP_LEVEL3_2_MENU_2, /* 40 燃油滤清器*/
    _MN_DSP_LEVEL3_2_MENU_3, /* 41 变速箱油*/
    _MN_DSP_LEVEL3_2_MENU_4, /* 42 差速器油*/
    _MN_DSP_LEVEL3_2_MENU_7, /* 43 动力转向液*/
    _MN_DSP_LEVEL3_2_MENU_8, /* 44 轮胎*/

    _MN_DSP_LEVEL3_3_MENU_1, /* 45 更换机油＆机油滤清器*/
    _MN_DSP_LEVEL3_3_MENU_2, /* 46 更换燃油滤清器*/
    _MN_DSP_LEVEL3_3_MENU_3, /* 47 更换变速箱油*/
    _MN_DSP_LEVEL3_3_MENU_4, /* 48 更换差速器油*/
    _MN_DSP_LEVEL3_3_MENU_6, /* 49 更换动力转向液*/
    _MN_DSP_LEVEL3_3_MENU_7, /* 50 轮胎换位・更换*/

    _MN_DSP_LEVEL3_4_MENU_11, /* 51 设定日期-年*/
    _MN_DSP_LEVEL3_4_MENU_12, /* 52 设定日期-月*/
    _MN_DSP_LEVEL3_4_MENU_13, /* 53 设定日期-日*/
    _MN_DSP_LEVEL3_4_MENU_21, /* 54 设定时间-时*/
    _MN_DSP_LEVEL3_4_MENU_22, /* 55 设定时间-分*/
    _MN_DSP_LEVEL3_4_MENU_3,  /* 56 设定语言*/
    _MN_DSP_LEVEL3_4_MENU_41, /* 57 速度设定－高速路*/
    _MN_DSP_LEVEL3_4_MENU_42, /* 58 速度设定－一般路*/
    _MN_DSP_LEVEL3_4_MENU_43, /* 59 发动机转速设定*/
    _MN_DSP_LEVEL3_4_MENU_44, /* 60 急加速设定*/
    _MN_DSP_LEVEL3_4_MENU_45, /* 61 急减速设定*/
    _MN_DSP_LEVEL3_4_MENU_46, /* 62 长时间怠速设定*/
    _MN_DSP_LEVEL3_4_MENU_47, /* 63 辅助驻车解除设定*/
    _MN_DSP_LEVEL3_4_MENU_5,  /* 64 轮胎匹配画面*/
    _MN_DSP_LEVEL3_7_MENU_1,  /* 65 亮度调节*/
    _MN_DSP_LEVEL3_7_MENU_2,  /* 66 亮度调节*/

    /*四级菜单*/
    _MN_DSP_LEVEL4_4_MENU_1, /* 67 速度设定-高速路*/
    _MN_DSP_LEVEL4_4_MENU_2, /* 68 速度设定-一般路*/
    _MN_DSP_LEVEL4_4_MENU_3, /* 69 发动机转速设定*/
    _MN_DSP_LEVEL4_4_MENU_4, /* 70 急加速设定*/
    _MN_DSP_LEVEL4_4_MENU_5, /* 71 急减速设定*/
    _MN_DSP_LEVEL4_4_MENU_6, /* 72 长时间怠速设定*/
    _MN_DSP_LEVEL4_4_MENU_7, /* 73 辅助驻车解除设定*/

    /*特殊界面*/
    _MN_DSP_ENTER_MENU,  /* 74 确认*/
    _MN_DSP_RETURN_MENU, /* 75 返回*/

    _MN_DSP_LEVEL3_5_MENU_1, /* 76 LDWS 警报演示*/
    _MN_DSP_LEVEL3_5_MENU_2, /* 77 AEBS第1警报演示*/
    _MN_DSP_LEVEL3_5_MENU_3, /* 78 AEBS第2警报演示*/
    _MN_DSP_LEVEL3_5_MENU_4, /* 79 AEBS全力制动警报演示*/

    _MN_DSP_Menu_OFF,  /* 80 */
    _MN_DSP_Menu_Test, /* 81 */

    /*工厂模式*/
    _FAC_DSP_LEVEL0MENU_1, /* 82 */

    _FAC_DSP_LEVEL1MENU_1, /* 83 DTC显示*/
    _FAC_DSP_LEVEL1MENU_2, /* 84 DTC清除*/
    _FAC_DSP_LEVEL1MENU_3, /* 85 仪表设定显示*/
    _FAC_DSP_LEVEL1MENU_4, /* 86 暂时通常模式*/
    _FAC_DSP_LEVEL1MENU_5, /* 87 结束工厂模式*/
    _FAC_DSP_LEVEL1MENU_6, /* 88 HID自动水平初始化*/

    _FAC_DSP_LEVEL1_1MENU_1, /* 89 故障码读取中*/

    _FAC_DSP_LEVEL1_2MENU_1, /* 90 清除所有DTC*/
    _FAC_DSP_LEVEL1_2MENU_2, /* 91 清除所有DTC*/
    _FAC_DSP_LEVEL1_2MENU_3, /* 92 */
    _FAC_DSP_LEVEL1_2MENU_4, /* 93 */

    _FAC_DSP_LEVEL1_3MENU_1, /* 94 L0-7 H2-A*/
    _FAC_DSP_LEVEL1_3MENU_2, /* 95 L8-F H2-A*/

    _FAC_DSP_LEVEL2_1MENU_1, /* 96 发动机故障*/
    _FAC_DSP_LEVEL2_1MENU_2, /* 97 SCR系统故障*/
    _FAC_DSP_LEVEL2_1MENU_3, /* 98 EBS/ABS故障*/
    _FAC_DSP_LEVEL2_1MENU_4, /* 99 仪表故障*/

    /*经销商模式*/
    _DEA_DSP_LEVEL0MENU_1,  /*100*/

    _DEA_DSP_LEVEL1MENU_1, /* 101 DTC显示*/
    _DEA_DSP_LEVEL1MENU_2, /* 102 DTC清除*/
    _DEA_DSP_LEVEL1MENU_3, /* 103 仪表设定显示*/
    _DEA_DSP_LEVEL1MENU_4, /* 104 暂时通常模式*/
    _DEA_DSP_LEVEL1MENU_5, /* 105 结束经销商模式*/
    _DEA_DSP_LEVEL1MENU_6, /* 106 HID自动水平初始化*/

    _DEA_DSP_LEVEL1_1MENU_1, /* 107 故障码读取中*/

    _DEA_DSP_LEVEL1_2MENU_1, /* 108 清除所有DTC*/
    _DEA_DSP_LEVEL1_2MENU_2, /* 109 清除所有DTC*/
    _DEA_DSP_LEVEL1_2MENU_3, /* 110 清除所有DTC*/
    _DEA_DSP_LEVEL1_2MENU_4, /* 111 清除所有DTC*/

    _DEA_DSP_LEVEL1_3MENU_1, /* 112 L0-7 H2-A*/
    _DEA_DSP_LEVEL1_3MENU_2, /* 113 L8-F H2-A*/

    _DEA_DSP_LEVEL2_1MENU_1, /* 114 发动机故障*/
    _DEA_DSP_LEVEL2_1MENU_2, /* 115 SCR系统故障*/
    _DEA_DSP_LEVEL2_1MENU_3, /* 116 EBS/ABS故障*/
    _DEA_DSP_LEVEL2_1MENU_4, /* 117 仪表故障*/

    _MN_DSP_MENU_MAX,

} _MenuCode;

typedef uint8_t _MENU_IDX;
typedef struct
{
    _MENU_IDX VK_IDX_ENTER;
    _MENU_IDX VK_IDX_UP;
    _MENU_IDX VK_IDX_DOWN;
    _MENU_IDX VK_IDX_EXIT;

    void (*Enter)(void);
    void (*Do)(void);
    void (*Exit)(void);
} _MenuOptTab;

typedef struct
{
    uint8_t Menu_Flag;             /*主界面标记*/
    uint8_t Menu_Time_Flag;        /*从Enter界面确认退出计时*/
    uint8_t Menu_Enter_Return;     /*进入Enter之前界面*/
    uint8_t Menu_Return;           /*Enter Return界面切换标记*/
    uint16_t Key_Menu_Popup_time;  /*报警状态持续时间*/
    uint8_t Menu_Key_Time;         /*按键长按时间记录*/
    uint8_t Key_Menu_Popup_Flag;   /*报警界面menu按键长按 */
    uint8_t Menu_Popup_Flag;       /*界面状态 0-通常 1-报警 2-工厂 3-经销商 4-仪表自我诊断*/
    uint8_t MenuNum;               /*未用*/
    uint8_t Key_MenuTest_Long;     /**/
    uint8_t Key_MenuTest_ShortNum; /**/
    uint8_t Menu_Factory;          /*工厂模式*/
    uint8_t Menu_Dealer;           /*经销商模式*/
    uint8_t Menu_Test;             /*仪表自我诊断模式*/
    uint8_t Meun_Test_Dealer;      /*自我诊断模式进入经销商模式标记*/

} _MenuFlag;

EXTERN_MEU_PROCESS _MenuFlag MenuFlag;

EXTERN_MEU_PROCESS uint8_t bMenuSwFlag;
EXTERN_MEU_PROCESS uint8_t g_ClearWin1;
EXTERN_MEU_PROCESS uint8_t bNextMenuIDX; // the next index of menu .
EXTERN_MEU_PROCESS uint8_t bCurMenuIDX;  // the current index of menu.
EXTERN_MEU_PROCESS uint8_t bMainMenuIDX; // the current index of menu.
EXTERN_MEU_PROCESS uint8_t bOldMenuIDX;  // the Old index of menu.

EXTERN_MEU_PROCESS const _MenuOptTab MenuOptTab[];
EXTERN_MEU_PROCESS void NextMenu(_MENU_IDX idx);
EXTERN_MEU_PROCESS void MenuInit(void);
EXTERN_MEU_PROCESS void MenuManage(void);

EXTERN_MEU_PROCESS void Level1Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level1Menu_1Do(void);
EXTERN_MEU_PROCESS void Level1Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level1Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level1Menu_2Do(void);
EXTERN_MEU_PROCESS void Level1Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level1Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level1Menu_3Do(void);
EXTERN_MEU_PROCESS void Level1Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level1Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level1Menu_4Do(void);
EXTERN_MEU_PROCESS void Level1Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level1Menu_5Enter(void);
EXTERN_MEU_PROCESS void Level1Menu_5Do(void);
EXTERN_MEU_PROCESS void Level1Menu_5Exit(void);

EXTERN_MEU_PROCESS void Level1Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level1Menu_6Do(void);
EXTERN_MEU_PROCESS void Level1Menu_6Exit(void);

EXTERN_MEU_PROCESS void LevelPopup_Enter(void);
EXTERN_MEU_PROCESS void LevelPopup_Do(void);
EXTERN_MEU_PROCESS void LevelPopup_Exit(void);

EXTERN_MEU_PROCESS void Level2Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level2Menu_2Do(void);
EXTERN_MEU_PROCESS void Level2Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level2Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level2Menu_3Do(void);
EXTERN_MEU_PROCESS void Level2Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level2Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level2Menu_4Do(void);
EXTERN_MEU_PROCESS void Level2Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level2Menu_5Enter(void);
EXTERN_MEU_PROCESS void Level2Menu_5Do(void);
EXTERN_MEU_PROCESS void Level2Menu_5Exit(void);

EXTERN_MEU_PROCESS void Level2Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level2Menu_6Do(void);
EXTERN_MEU_PROCESS void Level2Menu_6Exit(void);

EXTERN_MEU_PROCESS void Level2_1Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2_1Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2_1Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2_2Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2_2Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2_2Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2_2Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level2_2Menu_2Do(void);
EXTERN_MEU_PROCESS void Level2_2Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level2_2Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level2_2Menu_3Do(void);
EXTERN_MEU_PROCESS void Level2_2Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level2_2Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level2_2Menu_4Do(void);
EXTERN_MEU_PROCESS void Level2_2Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level2_2Menu_7Enter(void);
EXTERN_MEU_PROCESS void Level2_2Menu_7Do(void);
EXTERN_MEU_PROCESS void Level2_2Menu_7Exit(void);

EXTERN_MEU_PROCESS void Level2_2Menu_8Enter(void);
EXTERN_MEU_PROCESS void Level2_2Menu_8Do(void);
EXTERN_MEU_PROCESS void Level2_2Menu_8Exit(void);

EXTERN_MEU_PROCESS void Level2_3Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2_3Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2_3Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2_3Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level2_3Menu_2Do(void);
EXTERN_MEU_PROCESS void Level2_3Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level2_3Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level2_3Menu_3Do(void);
EXTERN_MEU_PROCESS void Level2_3Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level2_3Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level2_3Menu_4Do(void);
EXTERN_MEU_PROCESS void Level2_3Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level2_3Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level2_3Menu_6Do(void);
EXTERN_MEU_PROCESS void Level2_3Menu_6Exit(void);

EXTERN_MEU_PROCESS void Level2_3Menu_7Enter(void);
EXTERN_MEU_PROCESS void Level2_3Menu_7Do(void);
EXTERN_MEU_PROCESS void Level2_3Menu_7Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_2Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_7Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_7Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_7Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_3Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_4Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_5Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_5Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_5Exit(void);

EXTERN_MEU_PROCESS void Level2_4Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level2_4Menu_6Do(void);
EXTERN_MEU_PROCESS void Level2_4Menu_6Exit(void);

EXTERN_MEU_PROCESS void Level2_5Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2_5Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2_5Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2_5Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level2_5Menu_2Do(void);
EXTERN_MEU_PROCESS void Level2_5Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level2_5Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level2_5Menu_3Do(void);
EXTERN_MEU_PROCESS void Level2_5Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level2_5Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level2_5Menu_4Do(void);
EXTERN_MEU_PROCESS void Level2_5Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level2_6Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level2_6Menu_1Do(void);
EXTERN_MEU_PROCESS void Level2_6Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level2_6Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level2_6Menu_2Do(void);
EXTERN_MEU_PROCESS void Level2_6Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_1Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_2Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_3Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_4Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_6Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_6Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_7Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_7Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_7Exit(void);

EXTERN_MEU_PROCESS void Level3_2Menu_8Enter(void);
EXTERN_MEU_PROCESS void Level3_2Menu_8Do(void);
EXTERN_MEU_PROCESS void Level3_2Menu_8Exit(void);

EXTERN_MEU_PROCESS void Level3_3Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level3_3Menu_1Do(void);
EXTERN_MEU_PROCESS void Level3_3Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level3_3Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level3_3Menu_2Do(void);
EXTERN_MEU_PROCESS void Level3_3Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level3_3Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level3_3Menu_3Do(void);
EXTERN_MEU_PROCESS void Level3_3Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level3_3Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level3_3Menu_4Do(void);
EXTERN_MEU_PROCESS void Level3_3Menu_4Exit(void);

// EXTERN_MEU_PROCESS void Level3_3Menu_5Enter(void);
// EXTERN_MEU_PROCESS void Level3_3Menu_5Do(void);
// EXTERN_MEU_PROCESS void Level3_3Menu_5Exit(void);

EXTERN_MEU_PROCESS void Level3_3Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level3_3Menu_6Do(void);
EXTERN_MEU_PROCESS void Level3_3Menu_6Exit(void);

EXTERN_MEU_PROCESS void Level3_3Menu_7Enter(void);
EXTERN_MEU_PROCESS void Level3_3Menu_7Do(void);
EXTERN_MEU_PROCESS void Level3_3Menu_7Exit(void);

EXTERN_MEU_PROCESS void Level3_4Menu_1Enter_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_1Do_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_1Exit_1(void);

EXTERN_MEU_PROCESS void Level3_4Menu_1Enter_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_1Do_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_1Exit_2(void);

EXTERN_MEU_PROCESS void Level3_4Menu_1Enter_3(void);
EXTERN_MEU_PROCESS void Level3_4Menu_1Do_3(void);
EXTERN_MEU_PROCESS void Level3_4Menu_1Exit_3(void);

EXTERN_MEU_PROCESS void Level3_4Menu_2Enter_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_2Do_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_2Exit_1(void);

EXTERN_MEU_PROCESS void Level3_4Menu_2Enter_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_2Do_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_2Exit_2(void);

EXTERN_MEU_PROCESS void Level3_4Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level3_4Menu_3Do(void);
EXTERN_MEU_PROCESS void Level3_4Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_1(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_2(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_3(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_3(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_3(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_4(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_4(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_4(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_5(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_5(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_5(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_6(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_6(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_6(void);

EXTERN_MEU_PROCESS void Level3_4Menu_4Enter_7(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Do_7(void);
EXTERN_MEU_PROCESS void Level3_4Menu_4Exit_7(void);

EXTERN_MEU_PROCESS void Level3_4Menu_5Enter(void);
EXTERN_MEU_PROCESS void Level3_4Menu_5Do(void);
EXTERN_MEU_PROCESS void Level3_4Menu_5Exit(void);

EXTERN_MEU_PROCESS void Level3_4Menu_7Enter_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_7Do_1(void);
EXTERN_MEU_PROCESS void Level3_4Menu_7Exit_1(void);

EXTERN_MEU_PROCESS void Level3_4Menu_7Enter_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_7Do_2(void);
EXTERN_MEU_PROCESS void Level3_4Menu_7Exit_2(void);

EXTERN_MEU_PROCESS void Level3_5Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level3_5Menu_1Do(void);
EXTERN_MEU_PROCESS void Level3_5Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level3_5Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level3_5Menu_2Do(void);
EXTERN_MEU_PROCESS void Level3_5Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level3_5Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level3_5Menu_3Do(void);
EXTERN_MEU_PROCESS void Level3_5Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level3_5Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level3_5Menu_4Do(void);
EXTERN_MEU_PROCESS void Level3_5Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_1Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_1Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_1Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_2Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_2Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_2Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_3Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_3Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_3Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_4Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_4Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_4Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_5Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_5Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_5Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_6Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_6Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_6Exit(void);

EXTERN_MEU_PROCESS void Level4_4Menu_7Enter(void);
EXTERN_MEU_PROCESS void Level4_4Menu_7Do(void);
EXTERN_MEU_PROCESS void Level4_4Menu_7Exit(void);

EXTERN_MEU_PROCESS void Level_Enter_Menu_Enter(void);
EXTERN_MEU_PROCESS void Level_Enter_Menu_Do(void);
EXTERN_MEU_PROCESS void Level_Enter_Menu_Exit(void);

EXTERN_MEU_PROCESS void Level_Return_Menu_Enter(void);
EXTERN_MEU_PROCESS void Level_Return_Menu_Do(void);
EXTERN_MEU_PROCESS void Level_Return_Menu_Exit(void);

EXTERN_MEU_PROCESS void LevelMenuOFF_Enter(void);
EXTERN_MEU_PROCESS void LevelMenuOFF_Do(void);
EXTERN_MEU_PROCESS void LevelMenuOFF_Exit(void);

EXTERN_MEU_PROCESS void LevelMenuTest_Enter(void);
EXTERN_MEU_PROCESS void LevelMenuTest_Do(void);
EXTERN_MEU_PROCESS void LevelMenuTest_Exit(void);

/*工厂模式*/
EXTERN_MEU_PROCESS void LevelF0Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelF0Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelF0Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelF1Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelF1Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelF1Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelF1Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelF1Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelF1Menu_2Exit(void);

EXTERN_MEU_PROCESS void LevelF1Menu_3Enter(void);
EXTERN_MEU_PROCESS void LevelF1Menu_3Do(void);
EXTERN_MEU_PROCESS void LevelF1Menu_3Exit(void);

EXTERN_MEU_PROCESS void LevelF1Menu_4Enter(void);
EXTERN_MEU_PROCESS void LevelF1Menu_4Do(void);
EXTERN_MEU_PROCESS void LevelF1Menu_4Exit(void);

EXTERN_MEU_PROCESS void LevelF1Menu_5Enter(void);
EXTERN_MEU_PROCESS void LevelF1Menu_5Do(void);
EXTERN_MEU_PROCESS void LevelF1Menu_5Exit(void);

EXTERN_MEU_PROCESS void LevelF1Menu_6Enter(void);
EXTERN_MEU_PROCESS void LevelF1Menu_6Do(void);
EXTERN_MEU_PROCESS void LevelF1Menu_6Exit(void);

EXTERN_MEU_PROCESS void LevelF1_2Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelF1_2Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_2Exit(void);

EXTERN_MEU_PROCESS void LevelF1_2Menu_3Enter(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_3Do(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_3Exit(void);

EXTERN_MEU_PROCESS void LevelF1_2Menu_4Enter(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_4Do(void);
EXTERN_MEU_PROCESS void LevelF1_2Menu_4Exit(void);

EXTERN_MEU_PROCESS void LevelF1_3Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelF1_3Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelF1_3Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelF1_3Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelF1_3Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelF1_3Menu_2Exit(void);

EXTERN_MEU_PROCESS void LevelF1_1Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelF1_1Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_2Exit(void);

EXTERN_MEU_PROCESS void LevelF1_1Menu_3Enter(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_3Do(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_3Exit(void);

EXTERN_MEU_PROCESS void LevelF1_1Menu_4Enter(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_4Do(void);
EXTERN_MEU_PROCESS void LevelF1_1Menu_4Exit(void);

/*经销商模式*/
EXTERN_MEU_PROCESS void LevelD0Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelD0Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelD0Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelD1Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelD1Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelD1Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelD1Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelD1Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelD1Menu_2Exit(void);

EXTERN_MEU_PROCESS void LevelD1Menu_3Enter(void);
EXTERN_MEU_PROCESS void LevelD1Menu_3Do(void);
EXTERN_MEU_PROCESS void LevelD1Menu_3Exit(void);

EXTERN_MEU_PROCESS void LevelD1Menu_4Enter(void);
EXTERN_MEU_PROCESS void LevelD1Menu_4Do(void);
EXTERN_MEU_PROCESS void LevelD1Menu_4Exit(void);

EXTERN_MEU_PROCESS void LevelD1Menu_5Enter(void);
EXTERN_MEU_PROCESS void LevelD1Menu_5Do(void);
EXTERN_MEU_PROCESS void LevelD1Menu_5Exit(void);

EXTERN_MEU_PROCESS void LevelD1Menu_6Enter(void);
EXTERN_MEU_PROCESS void LevelD1Menu_6Do(void);
EXTERN_MEU_PROCESS void LevelD1Menu_6Exit(void);

EXTERN_MEU_PROCESS void LevelD1_1Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelD1_1Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelD1_1Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelD1_2Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelD1_2Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_2Exit(void);

EXTERN_MEU_PROCESS void LevelD1_2Menu_3Enter(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_3Do(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_3Exit(void);

EXTERN_MEU_PROCESS void LevelD1_2Menu_4Enter(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_4Do(void);
EXTERN_MEU_PROCESS void LevelD1_2Menu_4Exit(void);

EXTERN_MEU_PROCESS void LevelD1_3Menu_1Enter(void);
EXTERN_MEU_PROCESS void LevelD1_3Menu_1Do(void);
EXTERN_MEU_PROCESS void LevelD1_3Menu_1Exit(void);

EXTERN_MEU_PROCESS void LevelD1_3Menu_2Enter(void);
EXTERN_MEU_PROCESS void LevelD1_3Menu_2Do(void);
EXTERN_MEU_PROCESS void LevelD1_3Menu_2Exit(void);

#endif
